unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Run1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Run1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;


var
  Form1: TForm1;

implementation

uses
 EffectBass;

{$R *.DFM}

//------------------------------------------------------------------------------
// ֐    EffectGizaGizaHart
// pr      MUMUUCN
// 
//             hBMP             ...]TBitmap̃nh
//߂l@
//             rbg}bṽnh
// -----------------------------------------------------------------------------
function EffectGizaGizaHart(hBMP :HBitmap):HBitmap;
var
   Row,Col,i,j,x,y:Integer;
   _WIdth,_Height :integer;
   SrcRow :pRGBArray;
   SrcBitmap,DestBitmap :TBitmap;
   DestBits        :PPBits;
begin

    SrcBitmap:=TBitmap.Create;
    SrcBitmap.handle:=hBMP;

    if  (SrcBitmap.Width<6) or (SrcBitmap.Height<6)   then
    begin
      Result :=SrcBitmap.ReleaseHandle;
      SrcBitmap.Free;
      Exit;
    end;

    SrcBitmap.PIxelFormat:=pf24bit;
    DestBitmap:=TBitmap.Create;
    DestBitmap.Assign(SrcBitmap);

    _Height:=(SrcBitmap.Height div (5))-1;
    _Width :=(SrcBitmap.WIdth div (5))-1;

    GetMem(DestBits, DestBitmap.Height * SizeOf(pRGBArray));
   try

    for Row:= 0 to DestBitmap.Height - 1 do  DestBits[Row]:=DestBitmap.Scanline[Row];

    For Row:=0 to _Height do
    begin
         SrcRow:=SrcBitmap.ScanLine[Row*5];
         For Col:=0 to _Width do
         begin
            for i:=1 to 5 do
            begin
               for j:=1 to 3 do
               begin
                  Y:=Row*5+i ;
                  X:=Col*5+i+j;
                  if Y> DestBitmap.Height-1 then Y:=DestBitmap.Height-1 ;
                  if X> DestBitmap.Width-1  then X:=DestBitmap.Width-1 ;
                  DestBits[Y][X].rgbtRed  :=SrcRow[Col*5].rgbtRed;
                  DestBits[Y][X].rgbtGreen:=SrcRow[Col*5].rgbtGreen;
                  DestBits[Y][X].rgbtBlue :=SrcRow[Col*5].rgbtblue;
               end;
            end;
     end;
    end;

  FreeMem(DestBits); DestBits:=nil;
  Result :=DestBitmap.ReleaseHandle;

  except
     if Assigned(DestBits) then FreeMem(DestBits);
     Result :=SrcBitmap.ReleaseHandle;
  end;
  SrcBitmap.Free ;
  DestBitmap.Free;
end;

/////////
procedure TForm1.Open1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
 begin
   Image1.PIcture.Bitmap.LoadFromFIle(OpenDialog1.FIlename);
   Run1.Enabled :=true;
 end;
end;

/////////
procedure TForm1.Run1Click(Sender: TObject);
begin
   Image1.Picture.bitmap.Handle:= EffectGizaGizaHart(Image1.PIcture.Bitmap.ReleaseHandle);
   Run1.Enabled :=false;
end;

end.
